设为首页 收藏本站
查看: 760|回复: 0

shell if解释(二)

[复制链接]

尚未签到

发表于 2018-8-24 12:20:14 | 显示全部楼层 |阅读模式
  ---
  if 的三种条件表达式
if  command
  then
  if
  函数
  then
命令执行成功,等于返回0 (比如grep ,找到匹配)  执行失败,返回非0 (grep,没找到匹配)
if [ expression_r_r_r  ]  then
表达式结果为真,则返回0,if把0值引向thenif test expression_r_r_r  then
表达式结果为假,则返回非0,if把非0值引向then  [ ] &&  ——快捷if
[ -f "/etc/shadow" ] && echo "This computer uses shadow passwors"   && 可以理解为then  如果左边的表达式为真则执行右边的语句
  shell的if与c语言if的功能上的区别
shell if    c语言if0为真,走then 正好相反,非0走then 不支持整数变量直接if  必须:if [ i –ne 0 ]
  但支持字符串变量直接if
  if [ str ] 如果字符串非0
支持变量直接if  if (i )
  =================================以command作为if 条件===================================
  以多条command或者函数作为if 条件
echo –n “input:”  read user
  if
  多条指令,这些命令之间相当于“and”(与)
  grep $user /etc/passwd >/tmp/null
  who -u | grep $user
  then             上边的指令都执行成功,返回值$?为0,0为真,运行then
  echo "$user has logged"
  else     指令执行失败,$?为1,运行else
  echo "$user has not logged"
  fi
# sh test.sh  input : macg
  macg     pts/0        May 15 15:55   .          2075 (192.168.1.100)
  macg has logged
  # sh test.sh
  input : ddd
  ddd has not logged
  以函数作为if条件  (函数就相当于command,函数的优点是其return值可以自定义)
if  以函数作为if条件,
  getyn
  then   函数reture值0为真,走then
  echo " your answer is yes"
  else  函数return值非0为假,走else
  echo "your anser is no"
  fi
  if command  等价于 command+if $?
$ vi testsh.sh  #!/bin/sh
  if
  cat 111-tmp.txt | grep ting1
  then
  echo found
  else
  echo "no found"
  fi
$ vi testsh.sh  #!/bin/sh
  cat 111-tmp.txt | grep ting1
  if [ $? -eq 0 ]
  then
  echo $?
  echo found
  else
  echo $?
  echo "no found"
  fi
$ sh testsh.sh  no found
$ sh testsh.sh  1
  no found
$ vi 111-tmp.txt  that is 222file
  thisting1 is 111file
  $ sh testsh.sh
  thisting1 is 111file
  found
$ vi 111-tmp.txt  that is 222file
  thisting1 is 111file
  $ sh testsh.sh
  thisting1 is 111file
  0
  found
  ========================================以条件表达式作为 if条件=============================
  传统if 从句子——以条件表达式作为 if条件
  if [ 条件表达式 ]
  then
  command
  command
  command
  else
  command
  command
  fi

  •   字符串变量表达式
  If  [ $a = $b ]                 如果string1等于string2
  字符串允许使用赋值号做等号
  if  [ $string1 !=  $string2 ]   如果string1不等于string2
  if  [ -n $string  ]             如果string 非空(非0),返回0(true)
  if  [ -z $string  ]             如果string 为空
  if  [ $sting ]                  如果string 非空,返回0 (和-n类似)
  条件表达式引用变量要带$
if [ a = b ] ;then  echo equal
  else
  echo no equal
  fi
[macg@machome ~]$ sh test.sh  input a:
  5
  input b:
  5
  no equal  (等于表达式没比较$a和$b,而是比较和a和b,自然a!=b)
  改正:
if [ $a = $b ] ;then  echo equal
  else
  echo no equal
  fi
  -eq  -ne  -lt  -nt只能用于整数,不适用于字符串,字符串等于用赋值号=
[macg@machome ~]$ vi test.sh  echo -n "input your choice:"
  read var
  if  [ $var -eq "yes" ]
  then
  echo $var
  fi
  [macg@machome ~]$ sh -x test.sh
  input your choice:
  y
  test.sh: line 3: test: y: integer expression_r_r_r expected
  期望整数形式,即-eq不支持字符串
  =放在别的地方是赋值,放在if [ ] 里就是字符串等于,shell里面没有==的,那是c语言的等于
  无空格的字符串,可以加" ",也可以不加
[macg@machome ~]$ vi test.sh  echo "input a:"
  read a
  echo "input is $a"
  if [ $a = 123 ] ; then
  echo equal123
  fi
[macg@machome ~]$ sh test.sh  input a:
  123
  input is 123
  equal123
  = 作为等于时,其两边都必须加空格,否则失效
  等号也是操作符,必须和其他变量,关键字,用空格格开 (等号做赋值号时正好相反,两边不能有空格)
[macg@machome ~]$ vi test.sh  echo "input your choice:"
  read var
  if [ $var="yes" ]
  then
  echo $var
  echo "input is correct"
  else
  echo $var
  echo "input error"
  fi
[macg@machome ~]$ vi test.sh  echo "input your choice:"
  read var
  if [ $var = "yes" ]   在等号两边加空格
  then
  echo $var
  echo "input is correct"
  else
  echo $var
  echo "input error"
  fi
[macg@machome ~]$ sh test.sh  input your choice:
  y
  y
  input is correct
  [macg@machome ~]$ sh test.sh
  input your choice:
  n
  n
  input is correct
  输错了也走then,都走then,为什么?
  因为if把$var="yes"连读成一个变量,而此变量为空,返回1,则走else
[macg@machome ~]$ sh test.sh  input your choice:
  y
  y
  input error
  [macg@machome ~]$ sh test.sh
  input your choice:
  no
  no
  input error
  一切正常
  If  [  $ANS  ]     等价于  if [ -n $ANS ]
  如果字符串变量非空(then) , 空(else)
echo "input your choice:"  read ANS
  if [ $ANS ]
  then
  echo no empty
  else
  echo empth
  fi
[macg@machome ~]$ sh test.sh  input your choice:                       回车
  empth                                    说明“回车”就是空串
  [macg@machome ~]$ sh test.sh
  input your choice:
  34
  no empty
  整数条件表达式,大于,小于,shell里没有> 和< ,会被当作尖括号,只有-ge,-gt,-le,lt
[macg@machome ~]$ vi test.sh  echo "input a:"
  read a
  if  [ $a -ge 100 ] ; then
  echo 3bit
  else
  echo 2bit
  fi
[macg@machome ~]$ sh test.sh  input a:
  123
  3bit
  [macg@machome ~]$ sh test.sh
  input a:
  20
  2bit
  整数操作符号-ge,-gt,-le,-lt, 别忘了加-
if  test $a  ge 100 ; then  [macg@machome ~]$ sh test.sh
  test.sh: line 4: test: ge: binary operator expected
if  test $a -ge 100 ; then  [macg@machome ~]$ sh test.sh
  input a:
  123
  3bit
  ============================逻辑表达式=========================================
  逻辑非 !                   条件表达式的相反
  if [ ! 表达式 ]
  if [ ! -d $num ]                        如果不存在目录$num
  逻辑与 –a                    条件表达式的并列
  if [ 表达式1  –a  表达式2 ]
  逻辑或 -o                    条件表达式的或
  if [ 表达式1  –o 表达式2 ]
  最常见的赋值形式,赋值前对=两边的变量都进行评测
  左边测变量是否为空,右边测目录(值)是否存在(值是否有效)
[macg@mac-home ~]$ vi test.sh  :
  echo "input the num:"
  read num
  echo "input is $num"
  if [ -z "$JHHOME" -a -d $HOME/$num ]   如果变量$JHHOME为空,且$HOME/$num目录存在
  then
  JHHOME=$HOME/$num                      则赋值
  fi
  echo "JHHOME is $JHHOME"
-----------------------  [macg@mac-home ~]$ sh test.sh
  input the num:
  ppp
  input is ppp
  JHHOME is
  目录-d $HOME/$num   不存在,所以$JHHOME没被then赋值
[macg@mac-home ~]$ mkdir ppp  [macg@mac-home ~]$ sh test.sh
  input the num:
  ppp
  input is ppp
  JHHOME is /home/macg/ppp
  一个-o的例子,其中却揭示了”=”必须两边留空格的问题
echo "input your choice:"  read ANS
  if [ $ANS="Yes" -o $ANS="yes" -o $ANS="y" -o $ANS="Y" ]
  then
  ANS="y"
  else
  ANS="n"
  fi
  echo $ANS
[macg@machome ~]$ sh test.sh  input your choice:
  n
  y
  [macg@machome ~]$ sh test.sh
  input your choice:
  no
  y
  为什么输入不是yes,结果仍是y(走then)
  因为=被连读了,成了变量$ANS="Yes",而变量又为空,所以走else了
[macg@machome ~]$ vi test.sh  echo "input your choice:"
  read ANS    echo "input your choice:"
  read ANS
  if [ $ANS = "Yes" -o $ANS = "yes" -o $ANS = "y" -o $ANS = "Y" ]
  then
  ANS="y"
  else
  ANS="n"
  fi
  echo $ANS
[macg@machome ~]$ sh test.sh  input your choice:
  no
  n
  [macg@machome ~]$ sh test.sh
  input your choice:
  yes
  y
  [macg@machome ~]$ sh test.sh
  input your choice:
  y
  y
  最常用的简化if语句
&& 如果是“前面”,则“后面”  [ -f /var/run/dhcpd.pid ] && rm /var/run/dhcpd.pid    检查 文件是否存在,如果存在就删掉
||   如果不是“前面”,则后面  [ -f /usr/sbin/dhcpd ] || exit 0    检验文件是否存在,如果不存在就退出
用简化 if 和$1,$2,$3来检测参数,不合理就调用help  [ -z "$1" ] && help                 如果第一个参数不存在(-z  字符串长度为0 )
  [ "$1" = "-h" ] && help                        如果第一个参数是-h,就显示help
  --
  以下的例子证明了 TEST-COMMANDS 可以是任何有返回和退出状态的UNIX命令,之后 if 再次返回零的退出状态:
  anny ~> if ! grep $USER /etc/passwd
  More input> then echo "your user account is not managed locally"; fi
  your user account is not managed locally
  anny > echo $?
  0
  anny >
  以下能得到同样的结果:
  anny > grep $USER /etc/passwd
  anny > if [ $? -ne 0 ] ; then echo "not a local account" ; fi
  not a local account
  anny >
  ---
  7.1.2.2. 数字的比较
  以下的例子是用了数值的比较:
  anny > num=`wc -l work.txt`
  anny > echo $num
  201
  anny > if [ "$num" -gt "150" ]
  More input> then echo ; echo "you've worked hard enough for today."
  More input> echo ; fi
  you've worked hard enough for today.
  ---
  这个脚本在每个星期天由cron来执行。如果星期的数是偶数,他就提醒你把垃圾箱清理:
  #!/bin/bash
  # Calculate the week number using the date command:
  WEEKOFFSET=$[ $(date +"%V") % 2 ]
  # Test if we have a remainder.  If not, this is an even week so send a message.
  # Else, do nothing.
  if [ $WEEKOFFSET -eq "0" ]; then
  echo "Sunday evening, put out the garbage cans." | mail -s "Garbage cans out" your@your_domain.org
  --
  一个通过比较字符串来测试用户ID的例子:
  if [ "$(whoami)" != 'root' ]; then
  echo "You have no permission to run $0 as non-root user."
  exit 1;
  fi
  使用Bash,你可以缩短这样的结构。下面是以上测试的精简结构:
  [ "$(whoami)" != 'root' ] && ( echo you are using a non-privileged account; exit 1 )
  类似于如果测试为真就执行的 “&&” 表达式, “||” 指定了测试为假就执行。类似于 “&&” 表达式指明了在两个测试条件为真时所采取的动作,“||” 指明测试为假时所采取的行动。
[root@uyhd000225 ~]# su wencao  
bash-3.2$ echo $UID
  
504
  
bash-3.2$ id root
  
uid=0(root) gid=0(root) groups=0(root),1(bin),2(daemon),3(sys),4(adm),6(disk),10(wheel)
  
bash-3.2$ exit
  
exit
  
[root@uyhd000225 ~]# echo $UID
  
0
  
[root@uyhd000225 ~]#
  正则表达式也可以在比较中使用:
  anny > gender="female"
  anny > if [[ "$gender" == f* ]]
  More input> then echo "Pleasure to meet you, Madame."; fi
  Pleasure to meet you, Madame.
  多数程序员更喜欢使用和方括号相同作用的内建的 test 命令,像这样:
test "$(whoami)" != 'root' && (echo you are using a non-privileged account; exit 1)  参见信息页面得到更多关于Bash “(( EXPRESSION ))” 和 “` EXPRESSION `” 结构的模块匹配信息。
  -------------------
  OK,接下来自己写一个简单的挂载硬盘脚本,mount_disk.sh(windows下的ntfs格式硬盘)
#! /bin/sh  
dir_d=/media/disk_d
  
dir_e=/media/disk_e
  
dir_f=/media/disk_f
  

  
a=`ls $dir_d | wc -l`
  
b=`ls $dir_e | wc -l`
  
c=`ls $dir_f | wc -l`
  

  
echo "checking disk_d..."
  
if [ $a -eq 0 ]; then
  
  echo "disk_d is not exsit,now creating..."
  
  sudo mount -t ntfs /dev/disk/by-label/software /media/disk_d
  
else
  
  echo "disk_d exits"
  
fi
  

  
echo "checking disk_e..."
  
if [ $b -eq 0 ]; then
  
  echo "disk_e is not exsit,now creating..."
  
  sudo mount -t ntfs /dev/disk/by-label/elitor /media/disk_e
  
else
  
  echo "disk_e exits"
  
fi
  

  
echo "checking disk_f..."
  
if [ $c -eq 0 ]; then
  
  echo "disk_f is not exsit,now creating..."
  
  sudo mount -t ntfs /dev/disk/by-label/work /media/disk_f
  
else
  
  echo "disk_f exits"
  
fi
  二元比较操作符,比较变量或者比较数字.注意数字与字符串的区别.
  整数比较
  -eq 等于,如:if [ "$a" -eq "$b" ]
  -ne 不等于,如:if [ "$a" -ne "$b" ]
  -gt 大于,如:if [ "$a" -gt "$b" ]
  -ge 大于等于,如:if [ "$a" -ge "$b" ]
  -lt 小于,如:if [ "$a" -lt "$b" ]
  -le 小于等于,如:if [ "$a" -le "$b" ]
  大于(需要双括号),如:(("$a" > "$b"))
  >= 大于等于(需要双括号),如:(("$a" >= "$b"))
  小数据比较可使用AWK
  字符串比较
  = 等于,如:if [ "$a" = "$b" ]
  == 等于,如:if [ "$a" == "$b" ],与=等价
  注意:==的功能在[[]]和[]中的行为是不同的,如下:
  1 [[ $a == z* ]] # 如果$a以"z"开头(模式匹配)那么将为true
  2 [[ $a == "z*" ]] # 如果$a等于z*(字符匹配),那么结果为true
  3
  4 [ $a == z* ] # File globbing 和word splitting将会发生
  5 [ "$a" == "z*" ] # 如果$a等于z*(字符匹配),那么结果为true
  一点解释,关于File globbing是一种关于文件的速记法,比如"*.c"就是,再如~也是.
  但是file globbing并不是严格的正则表达式,虽然绝大多数情况下结构比较像.
  != 不等于,如:if [ "$a" != "$b" ]
  这个操作符将在[[]]结构中使用模式匹配.
  大于,在ASCII字母顺序下.如:
  if [[ "$a" > "$b" ]]
  if [ "$a" \> "$b" ]
  注意:在[]结构中">"需要被转义.
  具体参考Example 26-11来查看这个操作符应用的例子.
  -z 字符串为"null".就是长度为0.
  -n 字符串不为"null"
  注意:
  使用-n在[]结构中测试必须要用""把变量引起来.使用一个未被""的字符串来使用! -z
  或者就是未用""引用的字符串本身,放到[]结构中。虽然一般情况下可
  以工作,但这是不安全的.习惯于使用""来测试字符串是一种好习惯.
  截取:http://lxsym.blog.51cto.com/1364623/866331
  http://blog.sina.com.cn/s/blog_6151984a0100ekl6.html
  http://blog.chinaunix.net/uid-20788517-id-3135826.html



运维网声明 1、欢迎大家加入本站运维交流群:群②:261659950 群⑤:202807635 群⑦870801961 群⑧679858003
2、本站所有主题由该帖子作者发表,该帖子作者与运维网享有帖子相关版权
3、所有作品的著作权均归原作者享有,请您和我们一样尊重他人的著作权等合法权益。如果您对作品感到满意,请购买正版
4、禁止制作、复制、发布和传播具有反动、淫秽、色情、暴力、凶杀等内容的信息,一经发现立即删除。若您因此触犯法律,一切后果自负,我们对此不承担任何责任
5、所有资源均系网友上传或者通过网络收集,我们仅提供一个展示、介绍、观摩学习的平台,我们不对其内容的准确性、可靠性、正当性、安全性、合法性等负责,亦不承担任何法律责任
6、所有作品仅供您个人学习、研究或欣赏,不得用于商业或者其他用途,否则,一切后果均由您自己承担,我们对此不承担任何法律责任
7、如涉及侵犯版权等问题,请您及时通知我们,我们将立即采取措施予以解决
8、联系人Email:admin@iyunv.com 网址:www.yunweiku.com

所有资源均系网友上传或者通过网络收集,我们仅提供一个展示、介绍、观摩学习的平台,我们不对其承担任何法律责任,如涉及侵犯版权等问题,请您及时通知我们,我们将立即处理,联系人Email:kefu@iyunv.com,QQ:1061981298 本贴地址:https://www.yunweiku.com/thread-555965-1-1.html 上篇帖子: shell一些 下篇帖子: shell与if相关参数
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

扫码加入运维网微信交流群X

扫码加入运维网微信交流群

扫描二维码加入运维网微信交流群,最新一手资源尽在官方微信交流群!快快加入我们吧...

扫描微信二维码查看详情

客服E-mail:kefu@iyunv.com 客服QQ:1061981298


QQ群⑦:运维网交流群⑦ QQ群⑧:运维网交流群⑧ k8s群:运维网kubernetes交流群


提醒:禁止发布任何违反国家法律、法规的言论与图片等内容;本站内容均来自个人观点与网络等信息,非本站认同之观点.


本站大部分资源是网友从网上搜集分享而来,其版权均归原作者及其网站所有,我们尊重他人的合法权益,如有内容侵犯您的合法权益,请及时与我们联系进行核实删除!



合作伙伴: 青云cloud

快速回复 返回顶部 返回列表